Index: my-react-app/src/components/CustomerDetails.js
===================================================================
--- my-react-app/src/components/CustomerDetails.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
+++ my-react-app/src/components/CustomerDetails.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -0,0 +1,40 @@
+import React, { useEffect, useState } from 'react';
+import axios from 'axios';
+import { useParams } from 'react-router-dom';
+
+const CustomerDetails = () => {
+    const { id } = useParams();
+    const [customer, setCustomer] = useState(null);
+
+    useEffect(() => {
+        const fetchCustomer = async () => {
+            try {
+                const response = await axios.get(`http://localhost:8080/api/customers/${id}`);
+                setCustomer(response.data);
+            } catch (error) {
+                console.error('Error fetching customer:', error);
+            }
+        };
+
+        fetchCustomer();
+    }, [id]);
+
+    if (!customer) {
+        return <div>Loading...</div>;
+    }
+
+    return (
+        <div>
+            <h2>Customer Details</h2>
+            <p className="card-text"><strong>Email:</strong> {customer.email}</p>
+            <p className="card-text"><strong>Phone:</strong> {customer.phone}</p>
+            <p className="card-text"><strong>Address:</strong> {customer.address}</p>
+            <p className="card-text"><strong>Membership
+                Level:</strong> {customer.membershipLevel}</p>
+            <p className="card-text"><strong>Registration
+                Date:</strong> {new Date(customer.registrationDate).toLocaleString()}</p>
+        </div>
+    );
+}
+
+export default CustomerDetails;
Index: my-react-app/src/components/CustomerFormContainer.js
===================================================================
--- my-react-app/src/components/CustomerFormContainer.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
+++ my-react-app/src/components/CustomerFormContainer.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -0,0 +1,77 @@
+// CustomerFormContainer.js
+import React, { useState, useEffect } from 'react';
+import axios from 'axios';
+import CustomerForm from './CustomersForm';
+import MembershipsEnum from "./MembershipsEnum";
+import {useNavigate, useParams} from "react-router-dom";
+
+const CustomerFormContainer = () => {
+    const navigate = useNavigate();
+    const [formData, setFormData] = useState({
+        firstName: '',
+        lastName: '',
+        email: '',
+        password: '',
+        phone: '',
+        address: '',
+        membershipLevel: MembershipsEnum()[0]
+    });
+
+    const { id } = useParams();
+    const [customer, setCustomer] = useState(null);
+
+    useEffect(() => {
+        if (id) {
+            // Fetch customer data only if in edit mode
+            const fetchCustomer = async () => {
+                try {
+                    const response = await axios.get(`http://localhost:8080/api/customers/${id}`);
+                    const customerData = response.data;
+                    setFormData({
+                        firstName: customerData.firstName || '',
+                        lastName: customerData.lastName || '',
+                        email: customerData.email || '',
+                        password: '', // For security reasons, the password field should not be pre-filled
+                        phone: customerData.phone || '',
+                        address: customerData.address || '',
+                        membershipLevel: customerData.membershipLevel || MembershipsEnum()[0]
+                    });
+                } catch (error) {
+                    console.error('Error fetching customer:', error);
+                }
+            };
+
+            fetchCustomer();
+        }
+    }, [id]);
+
+    const handleChange = (e) => {
+        setFormData({ ...formData, [e.target.name]: e.target.value });
+    };
+
+    const handleSubmit = async (e) => {
+        e.preventDefault();
+        try {
+            if (customer) {
+                await axios.put(`http://localhost:8080/api/customers/edit/${customer.id}`, formData);
+            } else {
+                await axios.post("http://localhost:8080/api/customers", formData);
+            }
+            navigate("/customers");
+        } catch (error) {
+            navigate("/error");
+        }
+    };
+
+    return (
+        <CustomerForm
+            formData={formData}
+            handleChange={handleChange}
+            handleSubmit={handleSubmit}
+            membershipOptions={MembershipsEnum()}
+            isEdit={!!customer} // Pass a boolean indicating whether it's an update
+        />
+    );
+};
+
+export default CustomerFormContainer;
Index: my-react-app/src/components/Customers.js
===================================================================
--- my-react-app/src/components/Customers.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
+++ my-react-app/src/components/Customers.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -0,0 +1,75 @@
+import 'bootstrap/dist/css/bootstrap.min.css';
+import React, {useEffect, useState} from "react";
+import axios from "axios";
+import { Link } from 'react-router-dom';
+import { useNavigate } from 'react-router-dom';
+
+
+const Customers = () => {
+    const [customers, setCustomers] = useState([]);
+    const navigate = useNavigate();
+
+    useEffect(() => {
+        const fetchCustomers = async () => {
+            try {
+                const response = await axios.get("http://localhost:8080/api/customers");
+                setCustomers(response.data);
+            } catch (error) {
+                console.error("Error fetching customers: ", error);
+            }
+        };
+
+        fetchCustomers()
+    }, []);
+
+    const handleDetailClick = (customerId) => {
+        navigate(`/customers/${customerId}`);
+    }
+
+    const handleEditClick = (customerId) => {
+        navigate(`/customers/edit/${customerId}`);
+    }
+
+    const handleDeleteClick = async (customerId) => {
+        try {
+            await axios.delete(`http://localhost:8080/api/customers/delete/${customerId}`);
+            setCustomers(customers.filter(customer => customer.customerID !== customerId));
+            alert('Reservation canceled successfully');
+        } catch (error) {
+            console.error("Error + " + error);
+            alert("An error occurred while deleting");
+        }
+    }
+
+    return (
+        <div className="container mt-4">
+            <h1 className="mb-4">Customer List</h1>
+            <div className="row row-cols-1 row-cols-md-3 g-4">
+                {customers
+                    .filter(customer => customer.role !== 'admin')
+                    .map((customer) => (
+                        <div className="col" key={customer.customerId}>
+                            <div className="card h-100">
+                                <div className="card-body">
+                                    <h5 className="card-title">{customer.fullName}</h5>
+                                    <p className="card-text"><strong>Email:</strong> {customer.email}</p>
+                                    <p className="card-text"><strong>Phone:</strong> {customer.phone}</p>
+                                    <p className="card-text"><strong>Address:</strong> {customer.address}</p>
+                                    <p className="card-text"><strong>Membership
+                                        Level:</strong> {customer.membershipLevel}</p>
+                                    <p className="card-text"><strong>Registration
+                                        Date:</strong> {new Date(customer.registrationDate).toLocaleString()}</p>
+                                </div>
+                                <button onClick={() => handleDetailClick(customer.customerId)}>View Details</button>
+                                <button onClick={() => handleEditClick(customer.customerId)}>Edit</button>
+                                <button onClick={() => handleDeleteClick(customer.customerId)}>DELETE</button>
+                            </div>
+                        </div>
+                    ))}
+            </div>
+        </div>
+    );
+
+}
+
+export default Customers;
Index: my-react-app/src/components/CustomersForm.js
===================================================================
--- my-react-app/src/components/CustomersForm.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
+++ my-react-app/src/components/CustomersForm.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -0,0 +1,110 @@
+import React from 'react';
+import MembershipsEnum from "./MembershipsEnum";
+
+const CustomersForm = ({ formData, handleChange, handleSubmit, membershipOptions, isEdit}) => {
+    return (
+        <div>
+            <form onSubmit={handleSubmit} method="post">
+                <div>
+                    <label htmlFor="firstName">First Name</label>
+                    <div>
+                        <input
+                            type="text"
+                            id="firstName"
+                            name="firstName"
+                            value={formData.firstName}
+                            onChange={handleChange}
+                            required
+                        />
+                    </div>
+                </div>
+                <div>
+                    <label htmlFor="lastName">Last Name</label>
+                    <div>
+                        <input
+                            type="text"
+                            id="lastName"
+                            name="lastName"
+                            value={formData.lastName}
+                            onChange={handleChange}
+                            required
+                        />
+                    </div>
+                </div>
+                <div>
+                    <label htmlFor="email">Email</label>
+                    <div>
+                        <input
+                            type="email"
+                            id="email"
+                            name="email"
+                            value={formData.email}
+                            onChange={handleChange}
+                            required
+                        />
+                    </div>
+                </div>
+                <div>
+                    <label htmlFor="password">Password</label>
+                    <div>
+                        <input
+                            type="password"
+                            id="password"
+                            name="password"
+                            value={formData.password}
+                            onChange={handleChange}
+                            required
+                        />
+                    </div>
+                </div>
+                <div>
+                    <label htmlFor="phone">Phone</label>
+                    <div>
+                        <input
+                            type="text"
+                            id="phone"
+                            name="phone"
+                            value={formData.phone}
+                            onChange={handleChange}
+                            required
+                        />
+                    </div>
+                </div>
+                <div>
+                    <label htmlFor="address">Address</label>
+                    <div>
+                        <input
+                            type="text"
+                            id="address"
+                            name="address"
+                            value={formData.address}
+                            onChange={handleChange}
+                            required
+                        />
+                    </div>
+                </div>
+                <div>
+                    <label htmlFor="membershipLevel">Membership Type</label>
+                    <div>
+                        <select
+                            id="membershipLevel"
+                            name="membershipLevel"
+                            value={formData.membershipLevel}
+                            onChange={handleChange}
+                            required
+                        >
+                            {MembershipsEnum().map((membership, index) => (
+                                <option key={index} value={membership}>
+                                    {membership}
+                                </option>
+                            ))}
+                        </select>
+                    </div>
+                </div>
+                <button type="submit">{isEdit ? 'Update' : 'Register'}</button>
+            </form>
+        </div>
+    );
+};
+
+export default CustomersForm;
Index: my-react-app/src/components/ErrorPage.js
===================================================================
--- my-react-app/src/components/ErrorPage.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/ErrorPage.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,2 +1,3 @@
+// ErrorPage.js
 import React from 'react';
 
@@ -6,4 +7,5 @@
             <h1>Oops! Something went wrong.</h1>
             <p>Please try again later or contact support.</p>
+            {/* Add any additional content or error-specific messages */}
         </div>
     );
Index: my-react-app/src/components/Header.js
===================================================================
--- my-react-app/src/components/Header.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/Header.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,45 +1,6 @@
-import React, {useEffect, useState} from 'react';
-import { Link, useNavigate } from 'react-router-dom';
-import {jwtDecode} from "jwt-decode";
-import axios from "axios";
+import React from 'react';
+import { Link } from 'react-router-dom';
 
 const Header = () => {
-    const navigate = useNavigate();
-    const [user, setUser] = useState({});
-    const isLoggedIn = localStorage.getItem('token');
-
-    const handleLogout = () => {
-        localStorage.removeItem("token");
-        localStorage.removeItem("user");
-        setUser(null);
-        navigate("/login");
-
-    };
-
-    useEffect(() => {
-        const fetchUser = async () => {
-            try {
-                const token = localStorage.getItem("token");
-                if (!token) return;
-
-                const storedUser = localStorage.getItem("user");
-                if (storedUser) {
-                    setUser(JSON.parse(storedUser));
-                    return;
-                }
-
-                const decodedToken = jwtDecode(token);
-                const userId = decodedToken.iss;
-
-                const { data } = await axios.get(`http://localhost:8081/api/user/${userId}`);
-                setUser(data);
-                localStorage.setItem("user", JSON.stringify(data));
-            } catch (error) {
-                console.error("Error fetching user:", error);
-            }
-        };
-        fetchUser();
-    }, [isLoggedIn]);
-
     return (
         <header className="header navbar navbar-expand-lg navbar-light bg-light">
@@ -54,4 +15,10 @@
                         </li>
                         <li className="nav-item">
+                            <Link className="nav-link" to="/customers">Customers</Link>
+                        </li>
+                        <li className="nav-item">
+                            <Link className="nav-link" to="/customers/add">Add Customer</Link>
+                        </li>
+                        <li className="nav-item">
                             <Link className="nav-link" to="/restaurants">Restaurants</Link>
                         </li>
@@ -59,16 +26,4 @@
                             <Link className="nav-link" to="/reservations">Reservations</Link>
                         </li>
-                        <li className="nav-item">
-                            <Link className="nav-link" to="/reservations-past">Reservation history</Link>
-                        </li>
-                        <form className="form-inline mt-2 mt-md-0 ml-3">
-                            {isLoggedIn ? (
-                                <button className="btn btn-outline-danger ml-3" onClick={handleLogout}>
-                                    Logout {user?.firstName}
-                                </button>
-                            ) : (
-                                <Link className="btn btn-outline-info ml-3" to="/login">Login</Link>
-                            )}
-                        </form>
                     </ul>
                 </div>
Index: my-react-app/src/components/Layout.js
===================================================================
--- my-react-app/src/components/Layout.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/Layout.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,2 +1,3 @@
+// Layout.js
 import React from 'react';
 import Header from './Header';
Index: my-react-app/src/components/MembershipsEnum.js
===================================================================
--- my-react-app/src/components/MembershipsEnum.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/MembershipsEnum.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -3,5 +3,21 @@
 
 const MembershipsEnum = () => {
-    return ['GOLD', 'PLATINUM', 'STANDARD'];
+    const [memberships, setMemberships] = useState([]);
+
+    useEffect(() => {
+        const fetchMemberships = async () => {
+            try {
+                const response = await axios.get('http://localhost:8080/api/memberships');
+                // Assuming the response.data is an array of enum values
+                setMemberships(response.data);
+            } catch (error) {
+                console.error('Error fetching enum data:', error);
+            }
+        };
+
+        fetchMemberships();
+    }, []);
+
+    return memberships;
 };
 
Index: my-react-app/src/components/ReservationConfirmation.js
===================================================================
--- my-react-app/src/components/ReservationConfirmation.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/ReservationConfirmation.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -3,16 +3,9 @@
 import axios from 'axios';
 import { useNavigate } from 'react-router-dom';
-import { useLocation } from 'react-router-dom';
-import { jwtDecode } from "jwt-decode";
-import {request} from "../axios_helper";
-import restaurants from "./Restaurants";
 
 const ReservationConfirmation = () => {
     const navigate = useNavigate();
 
-    const location = useLocation();
-    const preOrderedItems = location.state?.preOrderedItems || [];
     const [restaurant, setRestaurant] = useState({});
-    const [user, setUser] = useState({});
     const [table, setTable] = useState({});
     const [reservationDateTime, setReservationDateTime] = useState('');
@@ -21,77 +14,46 @@
     const { tableNumber, timeSlot, restaurantId } = useParams();
 
-    const adjustedTimeSlot = new Date(new Date(timeSlot).getTime() + 60 * 60 * 1000).toISOString();
     useEffect(() => {
-        const fetchDetails = async () => {
+        const fetchTableDetails = async () => {
             try {
-                const tableResponse = await axios.get(`http://localhost:8081/api/tables/${tableNumber}`);
+                const tableResponse = await axios.get(`http://localhost:8080/api/tables/${tableNumber}`);
                 setTable(tableResponse.data);
-                const restaurantResponse = await axios.get(`http://localhost:8081/api/restaurants/${restaurantId}`);
+
+                const restaurantResponse = await axios.get(`http://localhost:8080/api/restaurants/${restaurantId}`);
                 setRestaurant(restaurantResponse.data);
-
-                const token = localStorage.getItem("token");
-                if (!token) {
-                    console.error("No token found");
-                    return;
-                }
-                const decodedToken = jwtDecode(token);
-                const userId = decodedToken.iss;
-
-                const userResponse = await axios.get(`http://localhost:8081/api/user/${userId}`);
-                setUser(userResponse.data);
             } catch (error) {
-                console.error('Error fetching table or restaurant details:', error);
+                console.error('Error fetching table details:', error);
             }
         };
-        fetchDetails();
+        fetchTableDetails();
     }, [tableNumber, restaurantId]);
 
     const handleSubmit = async (e) => {
         e.preventDefault();
+        // Handle form submission here
+        try {
+            // Check if restaurant and table are valid
+            if (!restaurant || !table) {
+                console.error("Restaurant or table is missing.");
+                return;
+            }
 
-        const payload = {
-            reservationID: 0,
-            userEmail: user.email,
-            rating: parseFloat(restaurant.rating) || null,
-            tableNumber: parseInt(table.id, 10),
-            restaurantId: restaurant.restaurantId,
-            reservationDateTime: adjustedTimeSlot,
-            partySize: parseInt(partySize, 10),
-            status: 'Reserved',
-            specialRequests: specialRequests.trim(),
-            paymentStatus: 'Pending',
-            preOrderedItems: preOrderedItems.map(item => ({
-                preorderedItemName: item.itemName,
-                quantity: item.quantity,
-                price: item.price,
-                menuID: item.menuID
-            }))
-        };
-
-
-        try {
-            const response = await axios.post('http://localhost:8081/api/reservations', payload, {
-                headers: {
-                    'Content-Type': 'application/json'
-                }
+            const response = await axios.post(`http://localhost:8080/api/reservations`, {
+                restaurant: restaurant, // Assuming restaurant has an 'id' property
+                table: table, // Assuming table has an 'id' property
+                checkInTime: timeSlot, // Fill in as needed
+                partySize: partySize,
+                specialRequests: specialRequests
             });
+            // Handle successful reservation creation
+            // console.log("Reservation created:", response.data);
             navigate("/reservations")
         } catch (error) {
-            if (error.response) {
-                alert('The selected time slot is no longer available. Please choose another time.');
-            } else {
-                alert('Network error. Please check your internet connection.');
-            }
+            console.error("Error creating reservation:", error);
         }
     };
 
-    const calculateCheckOutTime = (checkInTime) => {
-        const checkIn = new Date(checkInTime);
-        checkIn.setHours(checkIn.getHours() + 2);
-        return checkIn.toISOString();
-    };
-
     const initialRemainingTime = localStorage.getItem('remainingTime') || 300;
-    const [remainingTime, setRemainingTime] = useState(parseInt(initialRemainingTime, 10));
+    const [remainingTime, setRemainingTime] = useState(parseInt(initialRemainingTime));
 
     useEffect(() => {
@@ -99,5 +61,5 @@
             setRemainingTime((prevTime) => {
                 const newTime = prevTime - 1;
-                localStorage.setItem('remainingTime', newTime.toString());
+                localStorage.setItem('remainingTime', newTime.toString()); // Update remaining time in localStorage
                 return newTime;
             });
@@ -108,10 +70,10 @@
 
     useEffect(() => {
+        // Reset remaining time if it reaches zero
         if (remainingTime <= 0) {
             localStorage.removeItem('remainingTime');
-            alert("Time has expired. Please try reserving again.");
-            navigate('/restaurants');
+            // Optionally, handle releasing the hold on the table
         }
-    }, [remainingTime, navigate]);
+    }, [remainingTime]);
 
     const formatTime = (timeInSeconds) => {
@@ -120,17 +82,4 @@
         return `${minutes.toString().padStart(2, '0')}:${seconds.toString().padStart(2, '0')}`;
     };
-
-    const formatTimeSlot = (timeSlot) => {
-        const utcDate = new Date(timeSlot);
-        const localDate = new Date(utcDate.toLocaleString("en-US", { timeZone: Intl.DateTimeFormat().resolvedOptions().timeZone }));
-        const formattedDate = localDate.toLocaleDateString();
-        const formattedTime = localDate.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' });
-        return `${formattedDate} - ${formattedTime}`;
-    };
-
-    const grandTotal = preOrderedItems.reduce((acc, item) => acc + item.price * item.quantity, 0).toFixed(2);
-    const itemQuantityString = preOrderedItems
-        .map(item => `${item.itemName}:${item.quantity}`)
-        .join(',');
 
     return (
@@ -147,60 +96,29 @@
                                 <h5 className="card-title">Reservation Details</h5>
                                 <p className="card-text">
-                                    <strong>Restaurant:</strong> {restaurant.name || 'Loading...'} <br />
-                                    <strong>Cuisine type:</strong> {restaurant.cuisineType || 'Loading...'} <br />
-                                    <strong>Selected Time Slot:</strong> {formatTimeSlot(timeSlot)} <br />
-                                    <strong>Party size:</strong>{' '}
-                                    <input
-                                        type="number"
-                                        max={table.capacity}
-                                        value={partySize}
-                                        onChange={(e) => setPartySize(e.target.value)}
-                                    />
-                                    <strong>Table size:</strong> {table.capacity} <br />
-                                    <strong>Special Requests:</strong>{' '}
-                                    <input
-                                        type="text"
-                                        value={specialRequests}
-                                        onChange={(e) => setSpecialRequests(e.target.value)}
-                                    />
-                                    <br />
+                                    <strong>Restaurant:</strong> {restaurant.name || 'Loading...'} <br/>
+                                    <strong>Cuisine type:</strong> {restaurant.cuisineType || 'Loading...'} <br/>
+                                    <strong>Selected Time Slot:</strong> {timeSlot} <br/>
+                                    <strong>Party size:</strong> <input type="number" max={table.capacity}
+                                                                        value={partySize}
+                                                                        onChange={(e) => setPartySize(e.target.value)}/>
+                                    <strong>Table size:</strong> {table.capacity} <br/>
+                                    <strong>Special Requests:</strong> <input type="text" value={specialRequests}
+                                                                              onChange={(e) => setSpecialRequests(e.target.value)}/><br/>
                                 </p>
                                 <p className="card-text text-success">
-                                    <strong>
-                                        Check-in Time: Grace period of 15 minutes +/- the slot. For more information, call the restaurant.
-                                    </strong>
-                                    <br />
+                                    <strong>Check-in Time: grace period of 15 minutes +- the slot, for more call the
+                                        restaurant</strong><br/>
                                 </p>
-                                {preOrderedItems.length > 0 ? (
-                                    <div className="row">
-                                        {preOrderedItems.map((item) => (
-                                            <div key={item.menuID} className="col-md-4 mb-4">
-                                                <div className="list-group shadow-sm p-3">
-                                                    <p className="item"><strong>Item:</strong> {item.itemName}</p>
-                                                    <p className="item"><strong>Price:</strong> ${item.price.toFixed(2)}</p>
-                                                    <p className="item"><strong>Quantity:</strong> {item.quantity}</p>
-                                                    <p className="item"><strong>Total:</strong> ${(item.price * item.quantity).toFixed(2)}</p>
-                                                </div>
-                                            </div>
-                                        ))}
-
-                                        <div className="col-12 mt-4">
-                                            <div className="list-group shadow-sm p-4 text-center">
-                                                <h4>Grand Total: ${grandTotal}</h4>
-                                            </div>
-                                        </div>
-                                    </div>
-                                ) : (
-                                    <p>No pre-ordered items.</p>
-                                )}
                             </div>
                             <div className="card-footer">
                                 <button type="submit" className="btn btn-primary">Submit</button>
-                                <a href="/restaurants" className="btn btn-secondary mx-2">Back to Restaurants</a>
-                                <a href="/" className="btn btn-secondary">Back to Home</a>
+                            </div>
+                            <div className="col-md-6">
+                                <a href="/restaurants" className="btn btn-primary">Back to Home</a>
                             </div>
                         </form>
                     </div>
                 </div>
+
             </div>
         </div>
